package com.webflexexample.webflexExample.controller;


import com.webflexexample.webflexExample.mapper.EmployeeDto;
import com.webflexexample.webflexExample.service.EmployeeServiceImpl;
import lombok.AllArgsConstructor;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@RestController
@RequestMapping("/webfluxexample")
@AllArgsConstructor
public class EmployeeController {

    private EmployeeServiceImpl employeeService;

    @GetMapping(produces = MediaType.TEXT_EVENT_STREAM_VALUE)
    public Flux<EmployeeDto> getAllEmployees(){
        return employeeService.getAllEmployee();
    }
    @GetMapping(value = "/{id}", produces = MediaType.TEXT_EVENT_STREAM_VALUE)
    public Mono<EmployeeDto> getOneEmployee(@PathVariable String id){
        return employeeService.getEmployee(id);
    }
    @PostMapping
    public Mono<EmployeeDto> save(Mono<EmployeeDto> employeeDto){
        return employeeService.save(employeeDto);
    }

    /*@GetMapping(value = "/salary-range", produces = MediaType.TEXT_EVENT_STREAM_VALUE)
    public Flux<EmployeeDto> getProductBetweenRange(@RequestParam double min, @RequestParam double max) {
        return employeeService.getEmployeeInRange(min, max);
    }
*/
    @PutMapping(value = "/{id}", produces = MediaType.TEXT_EVENT_STREAM_VALUE)
    public Mono<EmployeeDto> updateEmployee(@RequestBody Mono<EmployeeDto> employeeDtoMono, @PathVariable String id) {
        return employeeService.updateProduct(employeeDtoMono, id);
    }

    @DeleteMapping(value = "/delete/{id}", produces = MediaType.TEXT_EVENT_STREAM_VALUE)
    public Mono<Void> deleteProduct(@PathVariable String id) {
        return employeeService.deleteProduct(id);
    }



}
