package com.webflexexample.webflexExample.router;

import com.webflexexample.webflexExample.handler.EmployeeHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.web.WebProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.reactive.function.server.RouterFunction;
import org.springframework.web.reactive.function.server.RouterFunctions;
import org.springframework.web.reactive.function.server.ServerResponse;

@Configuration
public class RouterConfig {

    @Autowired
    private EmployeeHandler employeeHandler;

    @Bean
    public WebProperties.Resources resources(){
        return new WebProperties.Resources();
    }

    @Bean
    public RouterFunction<ServerResponse> routerConfigs() {
        return RouterFunctions.route()
                .GET("/webfluxexample/employee/{id}",employeeHandler::getEmployee)
                .POST("webfluxexample/employee",employeeHandler::saveEmployee)
                .build();
    }
}
