package com.webflexexample.webflexExample.service;

import com.webflexexample.webflexExample.mapper.EmployeeDto;
import com.webflexexample.webflexExample.repository.EmployeeRepository;
import com.webflexexample.webflexExample.utils.EmployeeUtills;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Range;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
@Service
public class EmployeeServiceImpl implements EmployeeService{

    @Autowired
    EmployeeRepository employeeRepository;

    @Override
    public Flux<EmployeeDto> getAllEmployee() {
        return employeeRepository.findAll().map(EmployeeUtills::entityToDto);
    }

    public Mono<EmployeeDto> getEmployee(String id) {
        return employeeRepository.findById(id).map(EmployeeUtills::entityToDto);
    }


    @Override
    public Mono<EmployeeDto> save(Mono<EmployeeDto> employeeDto) {
        return employeeDto.map(EmployeeUtills::mapEmployeeDtoToEmployee).flatMap(employeeRepository::save).map(EmployeeUtills::entityToDto);
    }

    /*@Override
    public Flux<EmployeeDto> getEmployeeInRange(double min, double max) {
            return employeeRepository.employeeSalaryRange(Range.closed(min, max));
        }
*/
    @Override
    public Mono<EmployeeDto> updateProduct(Mono<EmployeeDto> employeeDtoMono, String id) {
        return employeeRepository.findById(id).flatMap(emp->employeeDtoMono.map(EmployeeUtills::mapEmployeeDtoToEmployee).doOnNext(e->e.setId(id))).flatMap(employeeRepository::save).map(EmployeeUtills::entityToDto);
    }

    @Override
    public Mono<Void> deleteProduct(String id) {
        return employeeRepository.deleteById(id);
    }


}
